/* TESTART - Article submission tester

Version 1.0

Portions copyrighted by System Enhancement Associates
and used with permission.

Description:

   This program attempts to test a file to see if it matches
   the specifications for FidoNews. Hopefully this will cut
   down the number of bad submissions that have been
   annoying this editor.

   Please try and test your own submissions before submitting
   them to FidoNews. If you do not have access to a C
   compiler, it should be available from 1/1 under the
   "magic" filename "TESTART" 

Note: This program has been tested with Microsoft Quick C and
C version 5.0 as well as Computer Innovations C86 Plus ver 1.1.

*/

#include <ctype.h>
#include <stdio.h>

main(argc,argv)
int argc;
char *argv[];

{
FILE *art;   /* file with article to test */
int c;       /* one character of file */
int peek;    /* another character of file */
int wid = 0; /* width counter */
int len = 0; /* length counter */



if (argc!=2)
   {
   printf("Incorrect usage. Correct usage is:\n\n");
   printf("testart <filename>\nWhere <filename> is the file ");
   printf("you are submitting.\n");
   exit(5);
   }

if ((art=fopen(argv[1],"r"))==NULL)
   {
   printf("Can not open the file: %s",argv[1]);
   exit(5);
   }
c=fgetc(art);

for( ; c!=EOF; c=fgetc(art))       /* scan the article */
   {
   printf("%1c",c);
   if(c=='\n')                   /* new line */
      wid = 0;                 /* reset width */

   else if(c>=' ' && c<='~' || c==0xfa || c==0xf6)
      wid++;

   else if(c==0x1d)
      {
      ungetc(peek=fgetc(art),art);
      if(isspace(peek))       /* these don't always add width */
         wid++;
      }

   else
      {
      printf("\n -- Illegal character (%02x hex)\n",c);
      exit(10);
      }

   if(!isspace(c))               /* check width */
      {
      if(wid>65)
         {
         printf("\n -- Line too long\n");
         exit(10);
         }
      }
   }

fclose(art);
printf("\nFidoNews Submission appears good.\n");

}
